﻿Type=Service
Version=7.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Dim snowboy As SnowBoy
	Dim wcl As wildcardlisting
	Dim hotwords As List
	Dim os As OutputStream
	Dim osa As OutputStream

End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.

End Sub

Sub Service_Start (StartingIntent As Intent)
	wcl.Initialize(Me,"wcl")
	wcl.ListFilesAndFolders(File.Combine(File.DirRootExternal, "snowboy/"), False, "*.umdl",True, True)
	hotwords.Initialize

End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub

Sub SnowboxInit(models As String, sensivity As String)
	snowboy.Initialize("Snowboy",File.Combine(File.DirRootExternal, "snowboy/common.res"),models,sensivity)
	Log("Snowboy initialized with "&snowboy.NumHotwords&" Hotwords...")
	CallSubDelayed(Main,"snowboyready")
	'btnRecord.Enabled = True
End Sub


Sub Snowboy_start()
	'Log($"Snowboy_start()"$)
	os = File.OpenOutput(File.DirRootExternal,"record.pcm",False)
End Sub
Sub Snowboy_AudioRecordStart()
	osa = File.OpenOutput(File.DirRootExternal,"recordaudio.pcm",False)
	
End Sub
Sub Snowboy_AudioRecordStop()
	osa.Flush
	osa.Close
	If File.Exists(File.DirRootExternal,"recordaudio.pcm") Then
		Log("recordaudio.pcm is "&File.Size(File.DirRootExternal,"recordaudio.pcm"))
	Else
		Log("recordaudio.pcm not found")
	End If
	
End Sub
Sub Snowboy_onHotword(hotword As Int)
	Log($"Snowboy_onHotword(${hotword} -> ${hotwords.Get(hotword-1)})"$)
End Sub

Sub Snowboy_onAudioRecordDataReceived(data() As Byte, length As Int)
	osa.WriteBytes(data,0,length)
End Sub
Sub Snowboy_onAudioDataReceived(audio() As Byte, i As Int)
	os.WriteBytes(audio,0,i)
	'Log($"Snowboy_onAudioDataReceived(${i},${audio})"$)
End Sub
Sub Snowboy_stop()
	'Log($"Snowboy_stop()"$)
	os.Flush
	os.Close
	If File.Exists(File.DirRootExternal,"record.pcm") Then
		Log("record.pcm is "&File.Size(File.DirRootExternal,"record.pcm"))
	Else
		Log("record.pcm not found")
	End If
End Sub


Sub wcl_FilesAndFoldersFinish(DirListing As List, FileListing As List)
	hotwords.Clear
	Dim models As String
	Dim sensivity As String
	Log("wcl_FilesAndFoldersFinish("&DirListing.Size&","&FileListing.Size&")")
	For i = 0 To DirListing.Size -1
		'Log(DirListing.Get(i))
	Next
	For i = 0 To FileListing.Size -1
		'Log(FileListing.Get(i))
		If i > 0 Then
			models = models&","
			sensivity = sensivity&","
		End If
		hotwords.Add(GetBasename(FileListing.Get(i)))
		models = models & File.Combine(File.DirRootExternal, "snowboy/"&GetFilename(FileListing.Get(i)))
		sensivity = sensivity&"0.5"
		Log(GetFilename(FileListing.Get(i)))
	Next
	Log($"======================"$)
	Log($"======================"$)
	Log($"${models}"$)
	Log($"======================"$)
	Log($"======================"$)
	SnowboxInit(models,sensivity)
End Sub
Sub wcl_DirListingError(error As String)
	Log("wcl_DirListingError("&error&")")
End Sub
Sub wcl_ListFilesFinish(FileListing As List)
	Log("wcl_ListFilesFinish("&FileListing.Size&")")
	For i = 0 To FileListing.Size -1
		Log(FileListing.Get(i))
	Next
End Sub
Sub wcl_ListFoldersFinish(DirListing As List)
	Log("wcl_ListFoldersFinish("&DirListing.Size&")")
	For i = 0 To DirListing.Size -1
		Log(DirListing.Get(i))
	Next
End Sub


Sub GetFilename(fullpath As String) As String
	Return fullpath.SubString(fullpath.LastIndexOf("/") + 1)
End Sub
Sub GetFileExt(FullPath As String) As String
	Return FullPath.SubString(FullPath.LastIndexOf(".")+1)
End Sub
Sub GetBasename(fullpath As String) As String
	Dim filename As String
	filename = GetFilename(fullpath)
	Return filename.SubString2(0,filename.LastIndexOf("."))
End Sub
Sub GetPath(Path As String) As String
	Dim L As Int
	Dim Path1 As String
	If Path = "/" Then
		Return "/"
	End If
	L = Path.LastIndexOf("/")
	If L = Path.Length - 1 Then
		'Strip the last slash
		Path1 = Path.SubString2(0,L)
	Else
		Path1 = Path
	End If
	L = Path.LastIndexOf("/")
	If L = 0 Then
		L = 1
	End If
	Return Path1.SubString2(0,L)
End Sub

